## pdp 0.14.1+darcs20180201

=== Makefile ===
include Makefile.config

# hc ?
#ifeq ($(OS_NAME),darwin)
#all: darwin
#else
#all: linux
#endif


all: $(PDP_TARGET)

everything: all
	make -C opengl
	make -C scaf

pdp_all:
	make -C system
	make -C puredata
	make -C modules

darwin:	pdp_all
	rm -f pdp.pd_darwin
	$(CC)  -o pdp.pd_darwin modules/*/*.o system/pdp.o system/*/*.o puredata/*.o $(PDP_LIBS) -bundle -undefined  dynamic_lookup  -twolevel_namespace -bundle_loader $(PD_EXECUTABLE) 


linux: pdp_all
	rm -f pdp.pd_linux
	$(CC) -rdynamic -shared -o pdp.pd_linux modules/*/*.o system/pdp.o system/*/*.o puredata/*.o $(PDP_LIBS)

linux_mmx: linux
linux_gcc_mmx: linux

buildclean:
	make -C include clean
	make -C system clean
	make -C puredata clean
	make -C modules clean

backupclean:
	rm -f *~ */*~ */*/*~

clean: buildclean backupclean
	rm -f pdp.pd_linux

distroclean: buildclean
	make -C scaf clean
	make -C opengl clean

mrproper: clean distroclean
	make -C scaf mrproper
	rm -rf configure
	rm -rf config.log
	rm -rf config.status
	rm -rf autom4te.cache
	#this needs to stay in to keep the makefiles working
	#rm -rf Makefile.config

tags:
	etags --language=auto include/*.h system/*.c system/mmx/*.s system/*/*.c puredata/*.c \
	modules/*/*.c scaf/*/*.c scaf/*/*.s opengl/*/*.c

tagsclean:
	rm -f TAGS


install: all
	#check if pd is installed. if this fails make install will stop here.
	test -d $(prefix)/lib/pd
	install -d $(prefix)/lib/pd/extra
	install -m 755 $(PDP_LIBRARY_NAME) $(prefix)/lib/pd/extra
	install -m 755 -d $(prefix)/include/pdp
	install -m 644 include/*.h $(prefix)/include/pdp
	install -m 644 abstractions/*.pd $(prefix)/lib/pd/extra
	install -m 644 doc/objects/*.pd $(prefix)/lib/pd/doc/5.reference
	install -m 755 -d $(prefix)/lib/pd/doc/pdp
	install -m 755 -d $(prefix)/lib/pd/doc/pdp/introduction
	install -m 755 -d $(prefix)/lib/pd/doc/pdp/examples
	install -m 644 doc/reference.txt $(prefix)/lib/pd/doc/pdp
	install -m 644 doc/introduction/*.pd $(prefix)/lib/pd/doc/pdp/introduction
	install -m 644 doc/examples/*.pd $(prefix)/lib/pd/doc/pdp/examples
	install -m 755 bin/pdp-config $(prefix)/bin

snapshot:
	bin/snapshot -d darcs

release:
	bin/snapshot `bin/release-version`
	@echo bump PDP_VERSION in configure.ac!

=== opengl/Makefile ===
include Makefile.config

all:	$(TARGET)

linux_gcc_mmx: linux
linux:	pdp_opengl.pd_linux

darwin:	pdp_opengl.pd_darwin

subdirs:
	make -C system
	make -C modules
	make -C include

clean:
	make -C system clean
	make -C modules clean
	make -C include clean
	rm -f pdp_opengl.pd_linux
	rm -f *~

# 3DP depends on glut for old drawing routines like "3dp_draw torus"
LDFLAGS_3DP := $(LDFLAGS) -lglut

pdp_opengl.pd_linux: subdirs
	rm -f pdp_opengl.pd_linux
	$(CC) -rdynamic -shared -o pdp_opengl.pd_linux modules/*.o system/*.o $(LDFLAGS_3DP) -g

pdp_opengl.pd_darwin: subdirs
	rm -f pdp_opengl.pd_linux
	$(CC) $(LDFLAGS_3DP) -o pdp_opengl.pd_darwin ../modules/*/*.o ../system/pdp.o ../system/*/*.o ../puredata/*.o modules/*.o system/*.o $(PDP_LIBS) -bundle -undefined dynamic_lookup -bundle_loader $(PD_EXECUTABLE)


# $(CC) -o pdp_opengl.pd_pd_darwin modules/*.o system/*.o $(LDFLAGS) -g -dynamic -bundle -flat_namespace -undefined suppress
# $(CC) -o pdp_opengl.pd_pd_darwin modules/*.o system/*.o $(LDFLAGS) -g -bundle -bundle_loader $(PD_EXECUTABLE)

install: all
	test -d $(prefix)/lib/pd 	#check if pd is installed. if this fails make install will stop here.
	install -d $(prefix)/lib/pd/extra
	install -m 755 $(PDP_OPENGL_LIBRARY_NAME) $(prefix)/lib/pd/extra
	install -m 644 abstractions/*.pd $(prefix)/lib/pd/extra
	install -m 644 doc/objects/*.pd $(prefix)/lib/pd/doc/5.reference
	install -m 755 -d $(prefix)/lib/pd/doc/pdp
	install -m 755 -d $(prefix)/lib/pd/doc/pdp/introduction
	install -m 755 -d $(prefix)/lib/pd/doc/pdp/examples_opengl
	install -m 644 doc/reference_opengl.txt $(prefix)/lib/pd/doc/pdp
	install -m 644 doc/examples/*.pd $(prefix)/lib/pd/doc/pdp/examples_opengl

=== puredata/Makefile ===

OBJECTS = pdp_base.o pdp_imagebase.o pdp_dpd_base.o  pdp_ut.o  pdp_queue.o pdp_comm.o \
	pdp_control.o pdp_compat.o $(PDP_PDMOD)


include ../Makefile.config

all: $(OBJECTS)

clean:
	rm -f *~
	rm -f *.o

=== scaf/Makefile ===
include Makefile.config


all: pdp_scaf.pd_linux

pdp_scaf_all:
	make -C include
	make -C compiler
	make -C rules
	make -C pdp

clean:
	rm -f *~
	rm -f pdp_scaf.pd_linux
	make -C include clean
	make -C compiler clean
	make -C rules clean
	make -C pdp clean

mrproper: clean
	rm -rf configure
	rm -rf config.status
	rm -rf config.log
	rm -rf autom4te.cache
	#this needs to stay in
	#rm -rf Makefile.config

pdp_scaf.pd_linux: pdp_scaf_all
	rm -f pdp_scaf.pd_linux
	gcc -rdynamic -shared -o pdp_scaf.pd_linux pdp/*.o $(PDP_CA_LIBS)

install: all
	install -d $(prefix)/lib/scaf
	install -m 755 compiler/scafc $(prefix)/bin || echo failed
	install -m 755 compiler/scafc.pl $(prefix)/lib/scaf || echo failed
	install -m 644 compiler/kernel.scaf $(prefix)/lib/scaf || echo failed
	install -m 644 compiler/scafmacro.s $(prefix)/lib/scaf || echo failed
	install -m 644 compiler/optim.rules $(prefix)/lib/scaf || echo failed
	install -m 755 rules/carules.scafo $(prefix)/lib/scaf/default.scafo || echo failed
	#Check if pd is installed in $(prefix)/lib/pd. 
	#If this fails the pdp_scaf lib and the docs won't be installed. 
	test -d $(prefix)/lib/pd
	install -m 755 pdp_scaf.pd_linux $(prefix)/lib/pd/extra
	install -m 644 doc/*.pd $(prefix)/lib/pd/doc/5.reference

=== modules/generic/Makefile ===
current: all_modules

include ../../Makefile.config

PDP_MOD = pdp_reg.o pdp_del.o pdp_snap.o pdp_trigger.o \
	pdp_route.o pdp_inspect.o pdp_loop.o pdp_description.o pdp_convert.o \
	pdp_udp_send.o pdp_udp_receive.o pdp_rawin.o pdp_rawout.o pdp_metro.o

# build generic modules
all_modules: $(PDP_MOD)

clean:
	rm -f *~
	rm -f *.o

=== modules/image_basic/Makefile ===
current: all_modules

include ../../Makefile.config

PDP_MOD = pdp_add.o pdp_conv.o \
	pdp_mix.o pdp_mul.o pdp_randmix.o \
	pdp_bq.o pdp_noise.o \
	pdp_gain.o pdp_zoom.o  \
	pdp_constant.o  \
	pdp_logic.o pdp_stateless.o pdp_plasma.o $(PDP_IMAGE_BASIC)


# build basic image processing modules (derived from base class)
all_modules: $(PDP_MOD)

clean:
	rm -f *~
	rm -f *.o

=== modules/image_io/Makefile ===
current: all_modules

include ../../Makefile.config

# build optional modules
all_modules: $(PDP_OPTMOD)

clean:
	rm -f *~
	rm -f *.o

=== modules/image_special/Makefile ===
current: all_modules

include ../../Makefile.config

PDP_MOD = pdp_chrot.o  pdp_grey2mask.o  pdp_scale.o  pdp_scan.o \
	  pdp_scanxy.o  pdp_scope.o  \
	pdp_cog.o pdp_array.o $(PDP_IMAGE_SPECIAL)

# build special case image (and sound) processing modules
all_modules: $(PDP_MOD)

clean:
	rm -f *~
	rm -f *.o

=== modules/matrix_basic/Makefile ===
current: all_modules

include ../../Makefile.config

PDP_MOD = $(PDP_MATRIX_BASIC)

all_modules: $(PDP_MOD)

clean:
	rm -f *~
	rm -f *.o

=== modules/test/Makefile ===
#current: all_modules
current: clean
include ../../Makefile.config

all_modules: pdp_forthtest.o

# build test modules
# all_modules: $(PDP_MOD)

clean:
	rm -f *~
	rm -f *.o

=== opengl/include/Makefile ===
all:

clean:
	rm -rf *~

=== opengl/modules/Makefile ===
include ../Makefile.config

all:	pdp_3d_windowcontext.o pdp_3d_draw.o pdp_3d_view.o \
	pdp_3d_push.o pdp_3d_light.o pdp_3d_dlist.o pdp_3d_color.o \
	pdp_3d_snap.o pdp_3d_drawmesh.o pdp_3d_for.o pdp_3d_state.o \
	pdp_3d_subcontext.o

clean:
	rm -rf *~ *.o

=== debian/changelog ===
pdp (1:0.14.1+darcs20180201-2) unstable; urgency=medium

  * Fix FTCBFS (Closes: #912347)
    * Fix build/host confusion
    * Let dh_auto_build pass cross tools to make.
    Thanks to Helmut Grohne <helmut@subdivi.de>
  * Declare that "root" is not required for building this package
  * Bumped standards version to 4.2.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 31 Oct 2018 09:49:53 +0100

pdp (1:0.14.1+darcs20180201-1) unstable; urgency=medium

  * New upstream version 0.14.1+darcs20180201

  * Refreshed patches
    * Dropped those applied upstream
    * Fixed spelling error in function declaration
  * Enabled full hardening
  * Adopted package into multimedia-team
  * Updated Vcs-* stanzas to salsa.d.o
  * Switched URLs to https://
  * Removed trailing whitespace in debian/*
  * Removed obsolete d/git-tuneclone.sh script
  * Updated d/copyright
    * Added d/copyright_hints
  * Bumped dh compat to 11
  * Bumped standards version to 4.1.3

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 06 Feb 2018 14:48:40 +0100

=== debian/control ===
Source: pdp
Section: graphics
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Paul Brossier <piem@debian.org>,
Build-Depends:
 debhelper (>=11~),
 docbook-to-man,
 puredata-dev | puredata (>= 0.38),
 libv4l-dev [linux-any],
 libquicktime-dev,
 libsdl1.2-dev,
 libpng-dev,
 libgsl-dev | libgsl0-dev,
 libxv-dev,
 freeglut3-dev,
Standards-Version: 4.2.1
Rules-Requires-Root: no
Homepage: http://zwizwa.be/pdp/
Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pdp.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/pdp

Package: pd-pdp
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 puredata | pd,
Recommends:
 pd-3dp,
 pd-scaf,
Description: Graphics system for Pd
 PDP is an extension library for Pd that allows you to manipulate movies
 and live video data in realtime. PDP stands for Pd Packet, the data
 container that is used for images in PDP.

Package: pd-3dp
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 pd-pdp,
Suggests:
 pd-scaf,
Description: openGL extensions for PDP
 PDP is an extension library for Pd that allows you to manipulate movies
 and live video data in realtime. PDP stands for Pd Packet, the data
 container that is used for images in PDP.
 .
 This library extends PDP with texture and render context packets,
 to use some of the power of current video hardware.
 .
 Warning: this is still experimental and incomplete!

Package: pd-scaf
Architecture: i386 amd64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 pd-pdp,
Description: Simple Cellular Automaton Forth for PDP
 PDP is an extension library for Pd that allows you to manipulate movies
 and live video data in realtime. PDP stands for Pd Packet, the data
 container that is used for images in PDP.
 .
 This is a PDP extension lib that contains modules for cellular
 automata built on a (very) minimal forth-like virtual system
 (scaf - simple cellular automaton forth) to define update rules.
 A compiler is included to produce 'scafo' object code that can be
 dynamically loaded into the [pdp_ca] module. So it is possible to
 add/change rules without restarting Pd.

=== debian/rules ===
#!/usr/bin/make -f

export PDP_EXTRA_CFLAGS = -fPIC -Wno-error $(CPPFLAGS) $(CFLAGS)
DPKG_EXPORT_BUILDFLAGS = 1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk


ifneq ($(filter amd64 i386,$(DEB_HOST_ARCH)),)
DEB_CONFIGURE_EXTRA_FLAGS = --enable-mmx
DEB_EXTRA_CFLAGS = -mmmx
BUILD_SCAF = yes
endif

%:
	dh $@

override_dh_autoreconf:
	dh_autoreconf --as-needed debian/autogen.sh

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)
	dh_auto_configure -Dscaf -- $(DEB_CONFIGURE_EXTRA_FLAGS)

override_dh_auto_build:
	dh_auto_build -- pdp_all
	dh_auto_build --buildsystem=makefile --sourcedirectory=opengl -- \
		LDFLAGS="$(LDFLAGS)" \
		PDP_EXTRA_CFLAGS="$(CFLAGS) $(DEB_EXTRA_CFLAGS)" \
		PDP_EXTRA_CPPFLAGS="$(CPPFLAGS)"
ifneq ($(BUILD_SCAF),)
	dh_auto_build --sourcedirectory=scaf -- \
		LDFLAGS="-fPIC $(LDFLAGS)" \
		PDP_CFLAGS="$(CPPFLAGS) -fPIC $(CFLAGS)"
	cp scaf/rules/carules.scafo scaf/rules/default.scafo
endif
	docbook-to-man debian/pdp-config.sgml > pdp-config.1

override_dh_auto_clean:
	[ ! -f opengl/Makefile.config ] || make -C opengl clean
	[ ! -f scaf/Makefile.config ] || make -C scaf clean
	[ ! -f Makefile.config ] || make clean
	-$(RM) -rf bin/pdp-config include/pdp_config.h
	-$(RM) -f Makefile.config config.log config.status
	-$(RM) -f scaf/Makefile.config scaf/config.log scaf/config.status
	-$(RM) -f pdp-config.1
	-$(RM) -f scaf/rules/default.scafo

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.LOG

override_dh_fixperms:
	dh_fixperms
	find debian -name '*.pd_linux' -exec \
		chmod 0644 {} +
	find debian -name '*.scafo' -exec \
		chmod 0644 {} +

licensecheck:
	licensecheck --deb-machine -r . \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

=== debian/watch ===
version=3

http://zwizwa.be/pd/pdp/pdp-([\d.]+)\.tar\.gz
